 /********************************************************************/
 /*  Program: AA_CREATE                                              */
 /*  Desc:    Create objects for Compile Utility. As noted below,    */
 /*             CNLLSTSPLF  cannot be created earlier than V5R1M0.   */
 /*  By:      Alan Campin                                            */
 /*  Date:    05/28/2006                                             */
 /*----------------------------------------------------------------  */
 /* Program Modification Section:                                    */
 /*  By..:                                                           */
 /*  Date:                                                           */
 /*  Desc:                                                           */
 /*                                                                  */
 /********************************************************************/
             PGM        PARM(&PGMLIB &SRCLIB &VERSION &COMPILECNL)

             DCL        VAR(&PGMLIB) TYPE(*CHAR) LEN(10) /* Library +
                          to compile objects to. */
             DCL        VAR(&SRCLIB) TYPE(*CHAR) LEN(10) /* Library +
                          where source if located. */
             DCL        VAR(&VERSION) TYPE(*CHAR) LEN(6) /* Version +
                          Number to compile to. */
             DCL        VAR(&COMPILECNL) TYPE(*CHAR) LEN(1) /* +
                          Compile CNLLSTSPLF? */

             ADDLIBLE   LIB(&PGMLIB)
             MONMSG     MSGID(CPF0000)

             DLTMSGF    MSGF(&PGMLIB/XVMSGF)
             MONMSG     MSGID(CPF0000)

             CRTMSGF    MSGF(&PGMLIB/XVMSGF) TEXT('System Utilities +
                          Message File.') AUT(*ALL)
             ADDMSGD    MSGID(UXV0001) MSGF(&PGMLIB/XVMSGF) +
                          MSG('*ERROR - Command EXTSRCCMD +
                          terminated abnormally for reason code &5! +
                          See second level help for reason.') +
                          SECLVL('Command EXTSRCCMD, Program +
                          XV0003AR was attempting to extract +
                          commands from source member &1, file +
                          &3/&2 but failed with reason code &5. +
                          Reason codes are as follows: &B 1. +
                          Maximum number of parameters (15) +
                          exceeded . &B 2. Parameter number greater +
                          than number loaded. &B 3. No parameters +
                          passed but parameters in commands. &B 4. +
                          Command too long (>512). &B 5. Unexpected +
                          command. Syntax error on last line. &P +
                          Actual Line "&4", &P  Syntax position &6, +
                          &P Character "&7", &P Section "&8"') +
                          SEV(99) FMT((*CHAR 10 0) (*CHAR 10 0) +
                          (*CHAR 10 0) (*CHAR 180 0) (*CHAR 3 0) +
                          (*DEC 3 0) (*CHAR 3) (*CHAR 15)) CCSID(*JOB)

             ADDMSGD    MSGID(UXV0002) MSGF(&PGMLIB/XVMSGF) MSG('&4 +
                          failed!') SECLVL('Command EXCSRCCMD, +
                          program XV0004C attempted to execute a +
                          command from source member &1, file +
                          &3/&2 but the command failed. This may or +
                          may not be an error. For example, +
                          attempting to delete a program but the +
                          program does not exist because the +
                          program has not been complied before +
                          generates an error but that may be what +
                          you would expect.') SEV(99) FMT((*CHAR +
                          10) (*CHAR 10) (*CHAR 10) (*CHAR 50)) +
                          CCSID(*JOB)

             ADDMSGD    MSGID(UXV0003) MSGF(&PGMLIB/XVMSGF) +
                          MSG('*ERROR - Command EXTSRCCMD failed +
                          with syntax error! See second level +
                          help.') SECLVL('Command EXTSRCCMD, +
                          program XV0003AR failed when a syntax +
                          error occurred processing commands from +
                          source member &1, file &3/&2. The error +
                          occurred at position &6, character "&7", +
                          section "&8". The actual source line was +
                          "&4". Syntax errors occur because the +
                          commands stored in source member has not +
                          been entered correctly.') SEV(99) +
                          FMT((*CHAR 10) (*CHAR 10) (*CHAR 10) +
                          (*CHAR 180) (*CHAR 3) (*DEC 3 0) (*CHAR +
                          3) (*CHAR 15)) CCSID(*JOB)

             ADDMSGD    MSGID(UXV0004) MSGF(&PGMLIB/XVMSGF) +
                          MSG('Command EXCSRCCMD aborted!') +
                          SECLVL('Command EXCSRCCMD, program +
                          XV0003AR was attempting to execute +
                          commands from source member &1, file +
                          &3/&2 but an error occurred (See previous +
                          message) and you requested that if an +
                          error occurred to terminate processing +
                          rather than continue. If this is not +
                          correct, run command again with *BYPASS +
                          for error action.') SEV(99) FMT((*CHAR +
                          10) (*CHAR 10) (*CHAR 10)) CCSID(*JOB)

             ADDMSGD    MSGID(UXV0005) MSGF(&PGMLIB/XVMSGF) +
                          MSG('Command EXCSRCCMD found no commands +
                          to execute!') SECLVL('Command EXCSRCCMD, +
                          program XV0004C found no commands to +
                          execute in source member &1, file &3/&2. +
                          Check the source member. All source lines +
                          containing commands must be marked with +
                          the following flag, "*_>", without the +
                          quotes. If the lines are not marked as +
                          extract lines, they will not be pulled. +
                          The flag should always start at position +
                          7 in the source record.') SEV(99) +
                          FMT((*CHAR 10) (*CHAR 10) (*CHAR 10)) +
                          CCSID(*JOB)

             ADDMSGD    MSGID(UXV0006) MSGF(&PGMLIB/XVMSGF) +
                          MSG('Command EXCSRCCMD completed +
                          normally! &4 commands executed. &5 +
                          failed.') SECLVL('Command EXCSRCCMD, +
                          program XV0004C finished processing +
                          source member &1, file &3/&2. &4 of the +
                          commands completed normally and &5 +
                          failed. As indicated in the failure +
                          messages, these errors may be expected.') +
                          SEV(99) FMT((*CHAR 10) (*CHAR 10) (*CHAR +
                          10) (*BIN 2) (*BIN 2))

             /* CNLLSTSPLF cannot be compiled earlier than V5R1M0 because it uses +
                  Free-Form RPG */
             IF         COND(&COMPILECNL *EQ 'Y') THEN(DO)
               DLTF       FILE(&PGMLIB/XVLCTF)
               MONMSG     MSGID(CPF0000)
               DLTMOD     MODULE(&PGMLIB/XV0008_M01)
               MONMSG     MSGID(CPF0000)
               DLTMOD     MODULE(&PGMLIB/XV0008_M02)
               MONMSG     MSGID(CPF0000)
               DLTPGM     PGM(&PGMLIB/XV0008)
               MONMSG     MSGID(CPF0000)
               DLTCMD     CMD(&PGMLIB/CNLLSTSPLF)
               MONMSG     MSGID(CPF0000)

               CRTPF      FILE(&PGMLIB/XVLCTF) +
                            SRCFILE(&PGMLIB/QSRCF) SRCMBR(XVLCTF)
               CRTCLMOD   MODULE(&PGMLIB/XV0008_M01) +
                            SRCFILE(&SRCLIB/QSRCF) +
                            SRCMBR(XV0008_M01) TGTRLS(&VERSION) +
                            OPTIMIZE(*BASIC) DBGVIEW(*LIST)
               CRTRPGMOD  MODULE(&PGMLIB/XV0008_M02) +
                            SRCFILE(&SRCLIB/QSRCF) SRCMBR(XV0008_M02) +
                            DBGVIEW(*LIST) OPTIMIZE(*BASIC) +
                            TGTRLS(&VERSION)
               CRTPGM     PGM(&PGMLIB/XV0008) +
                            MODULE(&PGMLIB/XV0008_M01 +
                            &PGMLIB/XV0008_M02) TEXT('CPP for +
                            CNLLSTSPLF.') ACTGRP(QILE) TGTRLS(&VERSION)
               CRTCMD     CMD(&PGMLIB/CNLLSTSPLF) +
                            PGM(&PGMLIB/XV0008) +
                            SRCFILE(&SRCLIB/QSRCF) SRCMBR(CNLLSTSPLF)
             ENDDO

             /* Create EXTSRCCMD - Extract commands from source member. */
             DLTPGM     PGM(&PGMLIB/XV0003C)
             MONMSG     MSGID(CPF0000)
             DLTPGM     PGM(&PGMLIB/XV0003AR)
             MONMSG     MSGID(CPF0000)
             DLTCMD     CMD(&PGMLIB/EXTSRCCMD)
             MONMSG     MSGID(CPF0000)

             CRTCLPGM   PGM(&PGMLIB/XV0003C) +
                          SRCFILE(&SRCLIB/QSRCF) SRCMBR(XV0003C) +
                          TGTRLS(&VERSION)
             CRTRPGPGM  PGM(&PGMLIB/XV0003AR) +
                          SRCFILE(&SRCLIB/QSRCF) SRCMBR(XV0003AR) +
                          TGTRLS(&VERSION)
             CRTCMD     CMD(&PGMLIB/EXTSRCCMD) +
                          PGM(&PGMLIB/XV0003C) +
                          SRCFILE(&SRCLIB/QSRCF) SRCMBR(EXTSRCCMD) +
                          ALLOW(*BPGM *IPGM *BMOD *IMOD *BREXX *IREXX)

             /* Create EXTSRCCMD - Execute Source Commands. */
             DLTPGM     PGM(&PGMLIB/XV0004C)
             MONMSG     MSGID(CPF0000)
             DLTCMD     CMD(&PGMLIB/EXCSRCCMD)
             MONMSG     MSGID(CPF0000)

             CRTCLPGM   PGM(&PGMLIB/XV0004C) +
                          SRCFILE(&SRCLIB/QSRCF) SRCMBR(XV0004C) +
                          TGTRLS(&VERSION)
             CRTCMD     CMD(&PGMLIB/EXCSRCCMD) PGM(&PGMLIB/XV0004C) +
                          SRCFILE(&SRCLIB/QSRCF) SRCMBR(EXCSRCCMD)

             /* Create COMPILE command. */
             DLTPGM     PGM(&PGMLIB/XV0005C)
             MONMSG     MSGID(CPF0000)
             DLTCMD     CMD(&PGMLIB/COMPILE)
             MONMSG     MSGID(CPF0000)

             CRTCLPGM   PGM(&PGMLIB/XV0005C) +
                          SRCFILE(&SRCLIB/QSRCF) SRCMBR(XV0005C) +
                          TGTRLS(&VERSION)
             CRTCMD     CMD(&PGMLIB/COMPILE) PGM(&PGMLIB/XV0005C) +
                          SRCFILE(&SRCLIB/QSRCF) SRCMBR(COMPILE)

             /* Create ChkOBJECT utility. */
             DLTCMD     CMD(&PGMLIB/CHKOBJECT)
             MONMSG     MSGID(CPF0000)
             DLTMOD     MODULE(&PGMLIB/XV0018_M01)
             MONMSG     MSGID(CPF0000)
             DLTPGM     PGM(&PGMLIB/XV0018)
             MONMSG     MSGID(CPF0000)

             CRTCLMOD   MODULE(&PGMLIB/XV0018_M01) +
                          SRCFILE(&SRCLIB/QSRCF) +
                          SRCMBR(XV0018_M01) TGTRLS(&VERSION) +
                          DBGVIEW(*LIST)
             CRTPGM     PGM(&PGMLIB/XV0018) +
                          MODULE(&PGMLIB/XV0018_M01) ACTGRP(QILE) +
                          TGTRLS(&VERSION)

             ENDPGM
